/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse ConfigParser_parse
#define yylex   ConfigParser_lex
#define yyerror ConfigParser_error
#define yylval  ConfigParser_lval
#define yychar  ConfigParser_char
#define yydebug ConfigParser_debug
#define yynerrs ConfigParser_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PRTOKEN_PIXEL_ATTRIBUTES = 258,
     PRTOKEN_SET_SIMPLE = 259,
     PRTOKEN_VISUAL_ID = 260,
     PRTOKEN_BUFFER_SIZE = 261,
     PRTOKEN_LEVEL = 262,
     PRTOKEN_RGBA = 263,
     PRTOKEN_DOUBLEBUFFER = 264,
     PRTOKEN_STEREO = 265,
     PRTOKEN_AUX_BUFFERS = 266,
     PRTOKEN_RED_SIZE = 267,
     PRTOKEN_GREEN_SIZE = 268,
     PRTOKEN_BLUE_SIZE = 269,
     PRTOKEN_ALPHA_SIZE = 270,
     PRTOKEN_DEPTH_SIZE = 271,
     PRTOKEN_STENCIL_SIZE = 272,
     PRTOKEN_ACCUM_RED_SIZE = 273,
     PRTOKEN_ACCUM_GREEN_SIZE = 274,
     PRTOKEN_ACCUM_BLUE_SIZE = 275,
     PRTOKEN_ACCUM_ALPHA_SIZE = 276,
     PRTOKEN_SAMPLES = 277,
     PRTOKEN_SAMPLE_BUFFERS = 278,
     PRTOKEN_RENDER_SURFACE = 279,
     PRTOKEN_WINDOW_RECT = 280,
     PRTOKEN_INPUT_RECT = 281,
     PRTOKEN_HOSTNAME = 282,
     PRTOKEN_DISPLAY = 283,
     PRTOKEN_SCREEN = 284,
     PRTOKEN_BORDER = 285,
     PRTOKEN_DRAWABLE_TYPE = 286,
     PRTOKEN_WINDOW_TYPE = 287,
     PRTOKEN_PBUFFER_TYPE = 288,
     PRTOKEN_CAMERA_GROUP = 289,
     PRTOKEN_CAMERA = 290,
     PRTOKEN_PROJECTION_RECT = 291,
     PRTOKEN_LENS = 292,
     PRTOKEN_FRUSTUM = 293,
     PRTOKEN_PERSPECTIVE = 294,
     PRTOKEN_ORTHO = 295,
     PRTOKEN_OFFSET = 296,
     PRTOKEN_ROTATE = 297,
     PRTOKEN_TRANSLATE = 298,
     PRTOKEN_SCALE = 299,
     PRTOKEN_SHEAR = 300,
     PRTOKEN_CLEAR_COLOR = 301,
     PRTOKEN_INPUT_AREA = 302,
     PRTOKEN_ERROR = 303,
     PRTOKEN_IDENTIFIER = 304,
     PRTOKEN_INTEGER = 305,
     PRTOKEN_HEX_INTEGER = 306,
     PRTOKEN_FLOAT = 307,
     PRTOKEN_TRUE = 308,
     PRTOKEN_FALSE = 309,
     PRTOKEN_QUOTED_STRING = 310,
     PRTOKEN_STEREO_SYSTEM_COMMANDS = 311,
     PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE = 312,
     PRTOKEN_METHOD = 313,
     PRTOKEN_PREMULTIPLY = 314,
     PRTOKEN_POSTMULTIPLY = 315,
     PRTOKEN_OVERRIDE_REDIRECT = 316,
     PRTOKEN_SHARELENS = 317,
     PRTOKEN_SHAREVIEW = 318,
     PRTOKEN_READ_DRAWABLE = 319,
     PRTOKEN_SET_RTT_MODE = 320,
     PRTOKEN_RTT_MODE_NONE = 321,
     PRTOKEN_RTT_MODE_RGB = 322,
     PRTOKEN_RTT_MODE_RGBA = 323,
     PRTOKEN_THREAD_MODEL = 324,
     PRTOKEN_SINGLE_THREADED = 325,
     PRTOKEN_THREAD_PER_CAMERA = 326,
     PRTOKEN_THREAD_PER_RENDER_SURFACE = 327,
     PRTOKEN_STEREO_SETTINGS = 328,
     PRTOKEN_MODE = 329,
     PRTOKEN_ANAGLYPHIC = 330,
     PRTOKEN_QUAD_BUFFER = 331,
     PRTOKEN_VERTICAL_INTERLACE = 332,
     PRTOKEN_HORIZONTAL_INTERLACE = 333,
     PRTOKEN_EYE_SEPARATION = 334,
     PRTOKEN_SCENE_HANDLER = 335
   };
#endif
/* Tokens.  */
#define PRTOKEN_PIXEL_ATTRIBUTES 258
#define PRTOKEN_SET_SIMPLE 259
#define PRTOKEN_VISUAL_ID 260
#define PRTOKEN_BUFFER_SIZE 261
#define PRTOKEN_LEVEL 262
#define PRTOKEN_RGBA 263
#define PRTOKEN_DOUBLEBUFFER 264
#define PRTOKEN_STEREO 265
#define PRTOKEN_AUX_BUFFERS 266
#define PRTOKEN_RED_SIZE 267
#define PRTOKEN_GREEN_SIZE 268
#define PRTOKEN_BLUE_SIZE 269
#define PRTOKEN_ALPHA_SIZE 270
#define PRTOKEN_DEPTH_SIZE 271
#define PRTOKEN_STENCIL_SIZE 272
#define PRTOKEN_ACCUM_RED_SIZE 273
#define PRTOKEN_ACCUM_GREEN_SIZE 274
#define PRTOKEN_ACCUM_BLUE_SIZE 275
#define PRTOKEN_ACCUM_ALPHA_SIZE 276
#define PRTOKEN_SAMPLES 277
#define PRTOKEN_SAMPLE_BUFFERS 278
#define PRTOKEN_RENDER_SURFACE 279
#define PRTOKEN_WINDOW_RECT 280
#define PRTOKEN_INPUT_RECT 281
#define PRTOKEN_HOSTNAME 282
#define PRTOKEN_DISPLAY 283
#define PRTOKEN_SCREEN 284
#define PRTOKEN_BORDER 285
#define PRTOKEN_DRAWABLE_TYPE 286
#define PRTOKEN_WINDOW_TYPE 287
#define PRTOKEN_PBUFFER_TYPE 288
#define PRTOKEN_CAMERA_GROUP 289
#define PRTOKEN_CAMERA 290
#define PRTOKEN_PROJECTION_RECT 291
#define PRTOKEN_LENS 292
#define PRTOKEN_FRUSTUM 293
#define PRTOKEN_PERSPECTIVE 294
#define PRTOKEN_ORTHO 295
#define PRTOKEN_OFFSET 296
#define PRTOKEN_ROTATE 297
#define PRTOKEN_TRANSLATE 298
#define PRTOKEN_SCALE 299
#define PRTOKEN_SHEAR 300
#define PRTOKEN_CLEAR_COLOR 301
#define PRTOKEN_INPUT_AREA 302
#define PRTOKEN_ERROR 303
#define PRTOKEN_IDENTIFIER 304
#define PRTOKEN_INTEGER 305
#define PRTOKEN_HEX_INTEGER 306
#define PRTOKEN_FLOAT 307
#define PRTOKEN_TRUE 308
#define PRTOKEN_FALSE 309
#define PRTOKEN_QUOTED_STRING 310
#define PRTOKEN_STEREO_SYSTEM_COMMANDS 311
#define PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE 312
#define PRTOKEN_METHOD 313
#define PRTOKEN_PREMULTIPLY 314
#define PRTOKEN_POSTMULTIPLY 315
#define PRTOKEN_OVERRIDE_REDIRECT 316
#define PRTOKEN_SHARELENS 317
#define PRTOKEN_SHAREVIEW 318
#define PRTOKEN_READ_DRAWABLE 319
#define PRTOKEN_SET_RTT_MODE 320
#define PRTOKEN_RTT_MODE_NONE 321
#define PRTOKEN_RTT_MODE_RGB 322
#define PRTOKEN_RTT_MODE_RGBA 323
#define PRTOKEN_THREAD_MODEL 324
#define PRTOKEN_SINGLE_THREADED 325
#define PRTOKEN_THREAD_PER_CAMERA 326
#define PRTOKEN_THREAD_PER_RENDER_SURFACE 327
#define PRTOKEN_STEREO_SETTINGS 328
#define PRTOKEN_MODE 329
#define PRTOKEN_ANAGLYPHIC 330
#define PRTOKEN_QUAD_BUFFER 331
#define PRTOKEN_VERTICAL_INTERLACE 332
#define PRTOKEN_HORIZONTAL_INTERLACE 333
#define PRTOKEN_EYE_SEPARATION 334
#define PRTOKEN_SCENE_HANDLER 335




/* Copy the first part of user declarations.  */
#line 24 ".././/ConfigParser.y"


#ifndef WIN32
#include <unistd.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <fcntl.h>
#endif

#ifndef WIN32
#define SUPPORT_CPP 1
#endif

#include <stdio.h>
#include <fstream>
#include <string>

#include "FlexLexer.h"

#include <Producer/CameraConfig.h>


using namespace std;
using namespace Producer;

static void ConfigParser_error( const char * );
static CameraConfig *cfg = 0L;
static std::string fileName = "(stdin)";

static yyFlexLexer *flexer = 0L;

static int yylex()
{
    if( flexer == 0L )
        fprintf( stderr, "Internal error!\n" );
    return flexer->yylex();
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 144 ".././/ConfigParser.y"
typedef union YYSTYPE {
    char * string;
    int    integer;
    float  real;
    bool boolean;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 300 "ConfigParser.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 312 "ConfigParser.cpp"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
	void *::malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void ::free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  32
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   337

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  86
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  53
/* YYNRULES -- Number of rules. */
#define YYNRULES  139
/* YYNRULES -- Number of states. */
#define YYNSTATES  294

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   335

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    85,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    84,    81,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    82,     2,    83,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    29,    33,    35,    37,    39,    45,
      50,    52,    53,    55,    58,    59,    66,    68,    71,    72,
      76,    78,    85,    89,    93,   100,   102,   104,   106,   108,
     109,   115,   117,   120,   125,   132,   138,   144,   148,   150,
     152,   157,   159,   162,   163,   172,   183,   190,   199,   208,
     219,   224,   229,   231,   234,   235,   239,   243,   245,   247,
     249,   251,   256,   261,   263,   264,   266,   267,   274,   276,
     279,   280,   284,   286,   293,   300,   304,   308,   312,   316,
     323,   327,   331,   335,   339,   341,   343,   345,   347,   349,
     350,   357,   358,   364,   366,   370,   372,   375,   378,   381,
     383,   385,   387,   390,   393,   396,   399,   402,   405,   408,
     411,   414,   417,   420,   423,   425,   428,   429,   435,   437,
     440,   444,   446,   448,   450,   452,   454,   456,   458,   460
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
      87,     0,    -1,    88,    -1,    89,    -1,    88,    89,    -1,
     123,    -1,   117,    -1,    97,    -1,   128,    -1,    94,    -1,
      93,    -1,    90,    -1,    91,    -1,    90,    91,    -1,    69,
      92,    81,    -1,    70,    -1,    71,    -1,    72,    -1,    56,
     134,   136,   136,    81,    -1,    34,    82,    95,    83,    -1,
      96,    -1,    -1,    97,    -1,    96,    97,    -1,    -1,    35,
     135,    98,    82,    99,    83,    -1,   100,    -1,    99,   100,
      -1,    -1,    24,   135,    81,    -1,   117,    -1,    36,   132,
     132,   132,   132,    81,    -1,    62,   138,    81,    -1,    63,
     138,    81,    -1,    46,   132,   132,   132,   132,    81,    -1,
     106,    -1,   101,    -1,   109,    -1,   113,    -1,    -1,    41,
      82,   102,   103,    83,    -1,   104,    -1,   103,   104,    -1,
      45,   132,   132,    81,    -1,    42,   132,   132,   132,   132,
      81,    -1,    43,   132,   132,   132,    81,    -1,    44,   132,
     132,   132,    81,    -1,    58,   105,    81,    -1,    59,    -1,
      60,    -1,    37,    82,   107,    83,    -1,   108,    -1,   107,
     108,    -1,    -1,    40,   132,   132,   132,   132,   132,   132,
      81,    -1,    40,   132,   132,   132,   132,   132,   132,   132,
     132,    81,    -1,    39,   132,   132,   132,   132,    81,    -1,
      39,   132,   132,   132,   132,   132,   132,    81,    -1,    38,
     132,   132,   132,   132,   132,   132,    81,    -1,    38,   132,
     132,   132,   132,   132,   132,   132,   132,    81,    -1,    45,
     132,   132,    81,    -1,    73,    82,   110,    83,    -1,   111,
      -1,   110,   111,    -1,    -1,    74,   112,    81,    -1,    79,
     132,    81,    -1,    75,    -1,    76,    -1,    77,    -1,    78,
      -1,    80,   114,   116,    81,    -1,   115,    84,    84,   115,
      -1,    49,    -1,    -1,    55,    -1,    -1,    24,   135,   118,
      82,   119,    83,    -1,   120,    -1,   119,   120,    -1,    -1,
       3,   135,    81,    -1,   123,    -1,    25,   134,   134,   134,
     134,    81,    -1,    26,   133,   133,   133,   133,    81,    -1,
      27,   135,    81,    -1,    28,   134,    81,    -1,    29,   134,
      81,    -1,    30,   138,    81,    -1,    57,   134,   134,   134,
     134,    81,    -1,    61,   138,    81,    -1,    31,   121,    81,
      -1,    64,   135,    81,    -1,    65,   122,    81,    -1,    32,
      -1,    33,    -1,    66,    -1,    67,    -1,    68,    -1,    -1,
       3,   135,   124,    82,   126,    83,    -1,    -1,     3,   125,
      82,   126,    83,    -1,   127,    -1,   126,    85,   127,    -1,
       4,    -1,     5,   137,    -1,     6,   134,    -1,     7,   134,
      -1,     8,    -1,     9,    -1,    10,    -1,    11,   134,    -1,
      12,   134,    -1,    13,   134,    -1,    14,   134,    -1,    15,
     134,    -1,    16,   134,    -1,    17,   134,    -1,    18,   134,
      -1,    19,   134,    -1,    20,   134,    -1,    21,   134,    -1,
      22,   134,    -1,    23,    -1,   134,   134,    -1,    -1,    47,
     129,    82,   130,    83,    -1,   131,    -1,   130,   131,    -1,
      24,   135,    81,    -1,    52,    -1,    50,    -1,    52,    -1,
      50,    -1,    55,    -1,    55,    -1,    51,    -1,    53,    -1,
      54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   163,   163,   166,   166,   169,   169,   169,   169,   169,
     169,   169,   172,   172,   176,   184,   185,   186,   189,   195,
     198,   201,   201,   201,   205,   204,   213,   213,   216,   218,
     222,   226,   230,   234,   238,   242,   243,   244,   245,   249,
     248,   258,   258,   262,   266,   270,   274,   278,   285,   286,
     289,   292,   292,   295,   297,   301,   305,   309,   313,   317,
     321,   327,   330,   330,   333,   335,   339,   345,   346,   347,
     348,   351,   356,   364,   370,   371,   377,   376,   387,   388,
     391,   393,   397,   401,   405,   409,   413,   417,   421,   425,
     429,   433,   438,   442,   449,   450,   454,   455,   456,   461,
     460,   470,   469,   480,   480,   483,   487,   492,   496,   501,
     505,   509,   513,   517,   522,   527,   531,   535,   539,   543,
     547,   551,   555,   559,   563,   567,   574,   573,   579,   579,
     583,   589,   593,   600,   606,   612,   618,   625,   633,   633
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PRTOKEN_PIXEL_ATTRIBUTES",
  "PRTOKEN_SET_SIMPLE", "PRTOKEN_VISUAL_ID", "PRTOKEN_BUFFER_SIZE",
  "PRTOKEN_LEVEL", "PRTOKEN_RGBA", "PRTOKEN_DOUBLEBUFFER",
  "PRTOKEN_STEREO", "PRTOKEN_AUX_BUFFERS", "PRTOKEN_RED_SIZE",
  "PRTOKEN_GREEN_SIZE", "PRTOKEN_BLUE_SIZE", "PRTOKEN_ALPHA_SIZE",
  "PRTOKEN_DEPTH_SIZE", "PRTOKEN_STENCIL_SIZE", "PRTOKEN_ACCUM_RED_SIZE",
  "PRTOKEN_ACCUM_GREEN_SIZE", "PRTOKEN_ACCUM_BLUE_SIZE",
  "PRTOKEN_ACCUM_ALPHA_SIZE", "PRTOKEN_SAMPLES", "PRTOKEN_SAMPLE_BUFFERS",
  "PRTOKEN_RENDER_SURFACE", "PRTOKEN_WINDOW_RECT", "PRTOKEN_INPUT_RECT",
  "PRTOKEN_HOSTNAME", "PRTOKEN_DISPLAY", "PRTOKEN_SCREEN",
  "PRTOKEN_BORDER", "PRTOKEN_DRAWABLE_TYPE", "PRTOKEN_WINDOW_TYPE",
  "PRTOKEN_PBUFFER_TYPE", "PRTOKEN_CAMERA_GROUP", "PRTOKEN_CAMERA",
  "PRTOKEN_PROJECTION_RECT", "PRTOKEN_LENS", "PRTOKEN_FRUSTUM",
  "PRTOKEN_PERSPECTIVE", "PRTOKEN_ORTHO", "PRTOKEN_OFFSET",
  "PRTOKEN_ROTATE", "PRTOKEN_TRANSLATE", "PRTOKEN_SCALE", "PRTOKEN_SHEAR",
  "PRTOKEN_CLEAR_COLOR", "PRTOKEN_INPUT_AREA", "PRTOKEN_ERROR",
  "PRTOKEN_IDENTIFIER", "PRTOKEN_INTEGER", "PRTOKEN_HEX_INTEGER",
  "PRTOKEN_FLOAT", "PRTOKEN_TRUE", "PRTOKEN_FALSE",
  "PRTOKEN_QUOTED_STRING", "PRTOKEN_STEREO_SYSTEM_COMMANDS",
  "PRTOKEN_CUSTOM_FULL_SCREEN_RECTANGLE", "PRTOKEN_METHOD",
  "PRTOKEN_PREMULTIPLY", "PRTOKEN_POSTMULTIPLY",
  "PRTOKEN_OVERRIDE_REDIRECT", "PRTOKEN_SHARELENS", "PRTOKEN_SHAREVIEW",
  "PRTOKEN_READ_DRAWABLE", "PRTOKEN_SET_RTT_MODE", "PRTOKEN_RTT_MODE_NONE",
  "PRTOKEN_RTT_MODE_RGB", "PRTOKEN_RTT_MODE_RGBA", "PRTOKEN_THREAD_MODEL",
  "PRTOKEN_SINGLE_THREADED", "PRTOKEN_THREAD_PER_CAMERA",
  "PRTOKEN_THREAD_PER_RENDER_SURFACE", "PRTOKEN_STEREO_SETTINGS",
  "PRTOKEN_MODE", "PRTOKEN_ANAGLYPHIC", "PRTOKEN_QUAD_BUFFER",
  "PRTOKEN_VERTICAL_INTERLACE", "PRTOKEN_HORIZONTAL_INTERLACE",
  "PRTOKEN_EYE_SEPARATION", "PRTOKEN_SCENE_HANDLER", "';'", "'{'", "'}'",
  "':'", "','", "$accept", "config", "entries", "entry", "system_params",
  "system_param", "threadModelDirective", "stereo_param", "camera_group",
  "camera_group_attributes", "cameras", "camera", "@1",
  "camera_attributes", "camera_attribute", "camera_offset", "@2",
  "camera_offset_attributes", "camera_offset_attribute",
  "offset_multiply_method", "lens", "lens_attributes", "lens_attribute",
  "stereo_settings", "stereo_setting_attributes",
  "stereo_setting_attribute", "stereo_mode", "scene_handler",
  "library_class", "identifier", "args", "render_surface", "@3",
  "render_surface_attributes", "render_surface_attribute", "drawableType",
  "rtt_mode", "visual", "@4", "@5", "pixel_attributes", "pixel_attribute",
  "input_area", "@6", "input_area_entries", "input_area_entry", "real",
  "floatparam", "intparam", "name", "string", "hex_integer", "bool", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    59,   123,   125,    58,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    86,    87,    88,    88,    89,    89,    89,    89,    89,
      89,    89,    90,    90,    91,    92,    92,    92,    93,    94,
      95,    96,    96,    96,    98,    97,    99,    99,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   102,
     101,   103,   103,   104,   104,   104,   104,   104,   105,   105,
     106,   107,   107,   108,   108,   108,   108,   108,   108,   108,
     108,   109,   110,   110,   111,   111,   111,   112,   112,   112,
     112,   113,   114,   115,   116,   116,   118,   117,   119,   119,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   121,   121,   122,   122,   122,   124,
     123,   125,   123,   126,   126,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   129,   128,   130,   130,
     131,   132,   132,   133,   134,   135,   136,   137,   138,   138
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     5,     4,
       1,     0,     1,     2,     0,     6,     1,     2,     0,     3,
       1,     6,     3,     3,     6,     1,     1,     1,     1,     0,
       5,     1,     2,     4,     6,     5,     5,     3,     1,     1,
       4,     1,     2,     0,     8,    10,     6,     8,     8,    10,
       4,     4,     1,     2,     0,     3,     3,     1,     1,     1,
       1,     4,     4,     1,     0,     1,     0,     6,     1,     2,
       0,     3,     1,     6,     6,     3,     3,     3,     3,     6,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     0,
       6,     0,     5,     1,     3,     1,     2,     2,     2,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     2,     0,     5,     1,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,   101,     0,     0,     0,   126,     0,     0,     0,     2,
       3,    11,    12,    10,     9,     7,     6,     5,     8,   135,
       0,    99,    76,    21,    24,     0,   134,     0,    15,    16,
      17,     0,     1,     4,    13,     0,     0,     0,     0,    20,
      22,     0,     0,   136,     0,    14,   105,     0,     0,     0,
     109,   110,   111,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   124,     0,   103,     0,     0,
      80,    19,    23,    28,     0,     0,   128,     0,   137,   106,
     107,   108,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   102,     0,   125,     0,   101,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    78,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,    36,    35,    37,    38,    30,     0,
     127,   129,    18,   104,   100,    99,     0,   133,     0,     0,
       0,     0,   138,   139,     0,    94,    95,     0,     0,     0,
       0,    96,    97,    98,     0,    77,    79,    76,   132,   131,
       0,    53,    39,     0,     0,     0,    64,    73,    74,     0,
      25,    27,   130,    81,     0,     0,    85,    86,    87,    88,
      91,     0,    90,    92,    93,    29,     0,     0,     0,     0,
       0,     0,    51,     0,     0,    32,    33,     0,     0,     0,
      62,    75,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,    52,     0,     0,     0,     0,     0,     0,
      41,     0,    67,    68,    69,    70,     0,     0,    61,    63,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    48,    49,     0,    40,    42,     0,
      65,    66,    72,    83,    84,    89,    31,     0,     0,     0,
      60,     0,     0,     0,     0,    47,    34,     0,     0,     0,
       0,     0,     0,    43,     0,    56,     0,     0,     0,    45,
      46,     0,     0,     0,    44,    58,     0,    57,    54,     0,
       0,     0,    59,    55
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     8,     9,    10,    11,    12,    31,    13,    14,    38,
      39,    15,    41,   122,   123,   124,   193,   219,   220,   246,
     125,   191,   192,   126,   199,   200,   226,   127,   168,   169,
     202,    16,    37,   110,   111,   147,   154,    17,    36,    20,
      66,    67,    18,    25,    75,    76,   160,   138,    68,    21,
      44,    79,   144
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -136
static const short int yypact[] =
{
      56,   -50,   -50,   -71,   -50,  -136,   -24,    67,    46,    56,
    -136,     6,  -136,  -136,  -136,  -136,  -136,  -136,  -136,  -136,
     -13,  -136,  -136,    60,  -136,     5,  -136,    44,  -136,  -136,
    -136,    24,  -136,  -136,  -136,   287,    25,    36,    37,    60,
    -136,    42,    98,  -136,    44,  -136,  -136,    75,   -24,   -24,
    -136,  -136,  -136,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
     -24,   -24,   -24,   -24,   -24,  -136,   -66,  -136,   -24,   287,
     214,  -136,  -136,   210,   -50,   -17,  -136,    62,  -136,  -136,
    -136,  -136,  -136,  -136,  -136,  -136,  -136,  -136,  -136,  -136,
    -136,  -136,  -136,  -136,  -136,   287,  -136,   -12,   -50,   -24,
      77,   -50,   -24,   -24,   -16,    83,   -24,   -16,   -50,    79,
       3,  -136,  -136,   -50,    52,    45,    59,    52,   -16,   -16,
      70,   116,    48,  -136,  -136,  -136,  -136,  -136,  -136,    85,
    -136,  -136,  -136,  -136,  -136,    92,   -24,  -136,    77,    93,
      95,    96,  -136,  -136,    97,  -136,  -136,   100,   -24,   104,
     109,  -136,  -136,  -136,   110,  -136,  -136,   111,  -136,  -136,
      52,    43,  -136,    52,   112,   113,   -56,  -136,   124,   115,
    -136,  -136,  -136,  -136,   -24,    77,  -136,  -136,  -136,  -136,
    -136,   -24,  -136,  -136,  -136,  -136,    52,    52,    52,    52,
      52,   -18,  -136,   106,    52,  -136,  -136,    94,    52,    40,
    -136,  -136,   114,   117,   -24,    77,   -24,    52,    52,    52,
      52,    52,  -136,  -136,    52,    52,    52,    52,    99,    34,
    -136,    52,  -136,  -136,  -136,  -136,   121,   125,  -136,  -136,
    -136,   116,   129,   130,   131,   137,    52,    52,    52,   138,
      52,    52,    52,    52,  -136,  -136,   140,  -136,  -136,   143,
    -136,  -136,  -136,  -136,  -136,  -136,  -136,    52,    52,    52,
    -136,    52,    52,    52,   144,  -136,  -136,    52,   -42,    52,
      52,   145,   147,  -136,    52,  -136,    52,    52,   149,  -136,
    -136,   -37,   150,   -36,  -136,  -136,    52,  -136,  -136,    52,
     152,   155,  -136,  -136
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -136,  -136,  -136,   171,  -136,   185,  -136,  -136,  -136,  -136,
    -136,   -14,  -136,  -136,   126,  -136,  -136,  -136,   -22,  -136,
    -136,  -136,    47,  -136,  -136,    38,  -136,  -136,  -136,    18,
    -136,   -61,  -136,  -136,   142,  -136,  -136,   -69,  -136,  -136,
     181,   158,  -136,  -136,  -136,   179,   -54,  -135,    -6,     0,
     211,  -136,   -83
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short int yytable[] =
{
      27,   112,    22,   175,    24,    19,    98,    74,   158,    40,
     159,    23,   128,   158,   158,   159,   159,    94,   197,    95,
     187,   188,   189,   198,   149,    72,    26,   190,    99,   100,
     101,   102,   103,   104,   105,   164,   165,   142,   143,   275,
     205,   112,    80,    81,   285,   288,    32,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,     1,
     106,   128,    96,   163,   107,   212,   130,   108,   109,    35,
     233,   134,   113,    95,   129,     7,   214,   215,   216,   217,
       2,   187,   188,   189,   114,   115,   155,    42,   190,   116,
       3,     4,   218,   136,   117,     4,   140,   141,   135,    43,
     148,   139,   158,     5,   159,    45,   186,    69,   150,   194,
     118,   119,     6,   157,   197,   145,   146,   247,    70,   198,
      71,   120,    74,   228,    73,     7,    78,   161,   121,   137,
     174,   170,   207,   208,   209,   210,   211,    28,    29,    30,
     221,   162,   181,   132,   227,   151,   152,   153,   214,   215,
     216,   217,   166,   235,   236,   237,   238,   239,   244,   245,
     240,   241,   242,   243,   218,   167,   172,   249,   204,   222,
     223,   224,   225,   173,   176,   206,   177,   178,   179,   201,
      33,   180,   257,   258,   259,   182,   261,   262,   263,   264,
     183,   184,   185,   195,   196,   230,    34,   248,   232,   203,
     234,   231,   250,   267,   268,   269,   251,   270,   271,   272,
     253,   254,   255,   274,   276,   277,   278,    98,   256,   260,
     281,   265,   282,   283,   266,   273,   279,   286,   280,   289,
     284,   287,   290,   292,   113,   291,   293,   229,   213,    99,
     100,   101,   102,   103,   104,   105,   114,   115,   171,   252,
      97,   116,   156,   133,   131,    77,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   118,   119,     0,   107,     0,     0,   108,   109,
       0,     0,     0,   120,     0,     0,     0,     0,     0,     0,
     121,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    26
};

static const short int yycheck[] =
{
       6,    70,     2,   138,     4,    55,     3,    24,    50,    23,
      52,    82,    73,    50,    50,    52,    52,    83,    74,    85,
      38,    39,    40,    79,   107,    39,    50,    45,    25,    26,
      27,    28,    29,    30,    31,   118,   119,    53,    54,    81,
     175,   110,    48,    49,    81,    81,     0,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,     3,
      57,   122,    68,   117,    61,    83,    83,    64,    65,    82,
     205,    83,    24,    85,    74,    69,    42,    43,    44,    45,
      24,    38,    39,    40,    36,    37,    83,    82,    45,    41,
      34,    35,    58,    99,    46,    35,   102,   103,    98,    55,
     106,   101,    50,    47,    52,    81,   160,    82,   108,   163,
      62,    63,    56,   113,    74,    32,    33,    83,    82,    79,
      83,    73,    24,    83,    82,    69,    51,    82,    80,    52,
     136,    83,   186,   187,   188,   189,   190,    70,    71,    72,
     194,    82,   148,    81,   198,    66,    67,    68,    42,    43,
      44,    45,    82,   207,   208,   209,   210,   211,    59,    60,
     214,   215,   216,   217,    58,    49,    81,   221,   174,    75,
      76,    77,    78,    81,    81,   181,    81,    81,    81,    55,
       9,    81,   236,   237,   238,    81,   240,   241,   242,   243,
      81,    81,    81,    81,    81,    81,    11,   219,   204,    84,
     206,    84,    81,   257,   258,   259,    81,   261,   262,   263,
      81,    81,    81,   267,   268,   269,   270,     3,    81,    81,
     274,    81,   276,   277,    81,    81,    81,   281,    81,   283,
      81,    81,   286,    81,    24,   289,    81,   199,   191,    25,
      26,    27,    28,    29,    30,    31,    36,    37,   122,   231,
      69,    41,   110,    95,    75,    44,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    62,    63,    -1,    61,    -1,    -1,    64,    65,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      80,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    24,    34,    35,    47,    56,    69,    87,    88,
      89,    90,    91,    93,    94,    97,   117,   123,   128,    55,
     125,   135,   135,    82,   135,   129,    50,   134,    70,    71,
      72,    92,     0,    89,    91,    82,   124,   118,    95,    96,
      97,    98,    82,    55,   136,    81,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,   126,   127,   134,    82,
      82,    83,    97,    82,    24,   130,   131,   136,    51,   137,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,    83,    85,   134,   126,     3,    25,
      26,    27,    28,    29,    30,    31,    57,    61,    64,    65,
     119,   120,   123,    24,    36,    37,    41,    46,    62,    63,
      73,    80,    99,   100,   101,   106,   109,   113,   117,   135,
      83,   131,    81,   127,    83,   135,   134,    52,   133,   135,
     134,   134,    53,    54,   138,    32,    33,   121,   134,   138,
     135,    66,    67,    68,   122,    83,   120,   135,    50,    52,
     132,    82,    82,   132,   138,   138,    82,    49,   114,   115,
      83,   100,    81,    81,   134,   133,    81,    81,    81,    81,
      81,   134,    81,    81,    81,    81,   132,    38,    39,    40,
      45,   107,   108,   102,   132,    81,    81,    74,    79,   110,
     111,    55,   116,    84,   134,   133,   134,   132,   132,   132,
     132,   132,    83,   108,    42,    43,    44,    45,    58,   103,
     104,   132,    75,    76,    77,    78,   112,   132,    83,   111,
      81,    84,   134,   133,   134,   132,   132,   132,   132,   132,
     132,   132,   132,   132,    59,    60,   105,    83,   104,   132,
      81,    81,   115,    81,    81,    81,    81,   132,   132,   132,
      81,   132,   132,   132,   132,    81,    81,   132,   132,   132,
     132,   132,   132,    81,   132,    81,   132,   132,   132,    81,
      81,   132,   132,   132,    81,    81,   132,    81,    81,   132,
     132,   132,    81,    81
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:
#line 177 ".././/ConfigParser.y"
    {
            Producer::CameraGroup::ThreadModel tm = (Producer::CameraGroup::ThreadModel)(yyvsp[-1].integer);
            cfg->setThreadModelDirective( tm );
        ;}
    break;

  case 15:
#line 184 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::SingleThreaded; ;}
    break;

  case 16:
#line 185 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::ThreadPerCamera; ;}
    break;

  case 17:
#line 186 ".././/ConfigParser.y"
    { (yyval.integer) = CameraGroup::ThreadPerRenderSurface; ;}
    break;

  case 18:
#line 190 ".././/ConfigParser.y"
    {
           cfg->addStereoSystemCommand( (yyvsp[-3].integer), (yyvsp[-2].string), (yyvsp[-1].string) );
        ;}
    break;

  case 24:
#line 205 ".././/ConfigParser.y"
    {
	    cfg->beginCamera( (yyvsp[0].string) );
	 ;}
    break;

  case 25:
#line 209 ".././/ConfigParser.y"
    {
	    cfg->endCamera();
	 ;}
    break;

  case 29:
#line 219 ".././/ConfigParser.y"
    {
	    cfg->setCameraRenderSurface( (yyvsp[-1].string) );
	;}
    break;

  case 30:
#line 223 ".././/ConfigParser.y"
    {
	    cfg->setCameraRenderSurface();
	;}
    break;

  case 31:
#line 227 ".././/ConfigParser.y"
    {
	    cfg->setCameraProjectionRectangle( (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	;}
    break;

  case 32:
#line 231 ".././/ConfigParser.y"
    {
	    cfg->setCameraShareLens( (yyvsp[-1].boolean) );
	;}
    break;

  case 33:
#line 235 ".././/ConfigParser.y"
    {
        cfg->setCameraShareView( (yyvsp[-1].boolean) );
    ;}
    break;

  case 34:
#line 239 ".././/ConfigParser.y"
    {
        cfg->setCameraClearColor( (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
    ;}
    break;

  case 39:
#line 249 ".././/ConfigParser.y"
    {
	    cfg->beginCameraOffset();
	;}
    break;

  case 40:
#line 253 ".././/ConfigParser.y"
    {
	    cfg->endCameraOffset();
	;}
    break;

  case 43:
#line 263 ".././/ConfigParser.y"
    {
	    cfg->shearCameraOffset( (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 44:
#line 267 ".././/ConfigParser.y"
    {
	    cfg->rotateCameraOffset( (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 45:
#line 271 ".././/ConfigParser.y"
    {
	    cfg->translateCameraOffset( (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 46:
#line 275 ".././/ConfigParser.y"
    {
	    cfg->scaleCameraOffset( (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 47:
#line 279 ".././/ConfigParser.y"
    {
	    cfg->setCameraOffsetMultiplyMethod( (Producer::Camera::Offset::MultiplyMethod)(yyvsp[-1].integer) );
	  ;}
    break;

  case 48:
#line 285 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::Offset::PreMultiply; ;}
    break;

  case 49:
#line 286 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::Offset::PostMultiply; ;}
    break;

  case 54:
#line 298 ".././/ConfigParser.y"
    {
	      cfg->setCameraOrtho( (yyvsp[-6].real), (yyvsp[-5].real), (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 55:
#line 302 ".././/ConfigParser.y"
    {
	      cfg->setCameraOrtho( (yyvsp[-8].real), (yyvsp[-7].real), (yyvsp[-6].real), (yyvsp[-5].real), (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 56:
#line 306 ".././/ConfigParser.y"
    {
	      cfg->setCameraPerspective( (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 57:
#line 310 ".././/ConfigParser.y"
    {
	      cfg->setCameraPerspective( (yyvsp[-6].real), (yyvsp[-5].real), (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 58:
#line 314 ".././/ConfigParser.y"
    {
	      cfg->setCameraFrustum( (yyvsp[-6].real), (yyvsp[-5].real), (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 59:
#line 318 ".././/ConfigParser.y"
    {
	      cfg->setCameraFrustum( (yyvsp[-8].real), (yyvsp[-7].real), (yyvsp[-6].real), (yyvsp[-5].real), (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 60:
#line 322 ".././/ConfigParser.y"
    {
	      cfg->setCameraLensShear( (yyvsp[-2].real), (yyvsp[-1].real) );
	  ;}
    break;

  case 65:
#line 336 ".././/ConfigParser.y"
    {
                 cfg->setCameraStereoSettingsMode( (Producer::Camera::StereoSettings::Mode)(yyvsp[-1].integer) );
             ;}
    break;

  case 66:
#line 340 ".././/ConfigParser.y"
    {
                 cfg->setCameraStereoSettingsEyeSeparation( (yyvsp[-1].real) );
            ;}
    break;

  case 67:
#line 345 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::Anaglyphic; ;}
    break;

  case 68:
#line 346 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::QuadBuffer; ;}
    break;

  case 69:
#line 347 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::VerticalInterlace; ;}
    break;

  case 70:
#line 348 ".././/ConfigParser.y"
    { (yyval.integer) = Producer::Camera::StereoSettings::HorizontalInterlace; ;}
    break;

  case 71:
#line 352 ".././/ConfigParser.y"
    {
                cfg->setCameraSceneHandler( (yyvsp[-2].string), (yyvsp[-1].string) );
            ;}
    break;

  case 72:
#line 357 ".././/ConfigParser.y"
    {
                char  buff[256];
                sprintf( buff, "%s::%s", (yyvsp[-3].string), (yyvsp[0].string) );

                (yyval.string) = strdup( buff );
            ;}
    break;

  case 73:
#line 365 ".././/ConfigParser.y"
    {
	            (yyval.string) = strdup( flexer->YYText() );
            ;}
    break;

  case 74:
#line 370 ".././/ConfigParser.y"
    { ; ;}
    break;

  case 75:
#line 372 ".././/ConfigParser.y"
    {
	        (yyval.string) = strdup( flexer->YYText() );
        ;}
    break;

  case 76:
#line 377 ".././/ConfigParser.y"
    {
	     cfg->beginRenderSurface( (yyvsp[0].string) );
	 ;}
    break;

  case 77:
#line 381 ".././/ConfigParser.y"
    {
	     cfg->endRenderSurface();
	 ;}
    break;

  case 81:
#line 394 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceVisualChooser( (yyvsp[-1].string) );
	;}
    break;

  case 82:
#line 398 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceVisualChooser();
	;}
    break;

  case 83:
#line 402 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceWindowRectangle( (yyvsp[-4].integer), (yyvsp[-3].integer), (yyvsp[-2].integer), (yyvsp[-1].integer) );
	;}
    break;

  case 84:
#line 406 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceInputRectangle( (yyvsp[-4].real), (yyvsp[-3].real), (yyvsp[-2].real), (yyvsp[-1].real) );
    ;}
    break;

  case 85:
#line 410 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceHostName( std::string((yyvsp[-1].string)) );
	;}
    break;

  case 86:
#line 414 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceDisplayNum( (yyvsp[-1].integer) );
	;}
    break;

  case 87:
#line 418 ".././/ConfigParser.y"
    {
	    cfg->setRenderSurfaceScreen( (yyvsp[-1].integer) );
	;}
    break;

  case 88:
#line 422 ".././/ConfigParser.y"
    {    
	    cfg->setRenderSurfaceBorder( (yyvsp[-1].boolean) );
	;}
    break;

  case 89:
#line 426 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceCustomFullScreenRectangle( (yyvsp[-4].integer), (yyvsp[-3].integer), (yyvsp[-2].integer), (yyvsp[-1].integer) );
    ;}
    break;

  case 90:
#line 430 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceOverrideRedirect( (yyvsp[-1].boolean) );
    ;}
    break;

  case 91:
#line 434 ".././/ConfigParser.y"
    {
        Producer::RenderSurface::DrawableType drawableType = (RenderSurface::DrawableType)(yyvsp[-1].integer);
        cfg->setRenderSurfaceDrawableType( drawableType );
    ;}
    break;

  case 92:
#line 439 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceReadDrawable( (yyvsp[-1].string) );
    ;}
    break;

  case 93:
#line 443 ".././/ConfigParser.y"
    {
        cfg->setRenderSurfaceRenderToTextureMode( (Producer::RenderSurface::RenderToTextureMode)(yyvsp[-1].integer) );
    ;}
    break;

  case 94:
#line 449 ".././/ConfigParser.y"
    { (yyval.integer) =  RenderSurface::DrawableType_Window; ;}
    break;

  case 95:
#line 450 ".././/ConfigParser.y"
    { (yyval.integer) =  RenderSurface::DrawableType_PBuffer; ;}
    break;

  case 96:
#line 454 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToTextureMode_None; ;}
    break;

  case 97:
#line 455 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToRGBTexture; ;}
    break;

  case 98:
#line 456 ".././/ConfigParser.y"
    { (yyval.integer) = RenderSurface::RenderToRGBATexture; ;}
    break;

  case 99:
#line 461 ".././/ConfigParser.y"
    {
	     cfg->beginVisual( (yyvsp[0].string) );
	 ;}
    break;

  case 100:
#line 465 ".././/ConfigParser.y"
    {
	     cfg->endVisual();
	 ;}
    break;

  case 101:
#line 470 ".././/ConfigParser.y"
    {
	     cfg->beginVisual();
	 ;}
    break;

  case 102:
#line 474 ".././/ConfigParser.y"
    {
	     cfg->endVisual();
	 ;}
    break;

  case 105:
#line 484 ".././/ConfigParser.y"
    {
	      cfg->setVisualSimpleConfiguration();
	  ;}
    break;

  case 106:
#line 488 ".././/ConfigParser.y"
    {
	      cfg->setVisualByID( (yyvsp[0].integer) );
	  ;}
    break;

  case 107:
#line 493 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::BufferSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 108:
#line 497 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Level, (yyvsp[0].integer) );
	  ;}
    break;

  case 109:
#line 502 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::RGBA );
	  ;}
    break;

  case 110:
#line 506 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::DoubleBuffer );
	  ;}
    break;

  case 111:
#line 510 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Stereo );
	  ;}
    break;

  case 112:
#line 514 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AuxBuffers, (yyvsp[0].integer) );
	  ;}
    break;

  case 113:
#line 518 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::RedSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 114:
#line 523 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::GreenSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 115:
#line 528 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::BlueSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 116:
#line 532 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AlphaSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 117:
#line 536 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::DepthSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 118:
#line 540 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::StencilSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 119:
#line 544 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumRedSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 120:
#line 548 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumGreenSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 121:
#line 552 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumBlueSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 122:
#line 556 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::AccumAlphaSize, (yyvsp[0].integer) );
	  ;}
    break;

  case 123:
#line 560 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::Samples, (yyvsp[0].integer) );
      ;}
    break;

  case 124:
#line 564 ".././/ConfigParser.y"
    {
	      cfg->addVisualAttribute( VisualChooser::SampleBuffers );
	  ;}
    break;

  case 125:
#line 568 ".././/ConfigParser.y"
    {
	      cfg->addVisualExtendedAttribute( (yyvsp[-1].integer), (yyvsp[0].integer) );
	  ;}
    break;

  case 126:
#line 574 ".././/ConfigParser.y"
    { cfg->beginInputArea(); ;}
    break;

  case 127:
#line 576 ".././/ConfigParser.y"
    { cfg->endInputArea(); ;}
    break;

  case 130:
#line 584 ".././/ConfigParser.y"
    {
			cfg->addInputAreaEntry( (yyvsp[-1].string) );
		;}
    break;

  case 131:
#line 590 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 132:
#line 594 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 133:
#line 601 ".././/ConfigParser.y"
    {
	    (yyval.real) = atof(flexer->YYText());
	;}
    break;

  case 134:
#line 607 ".././/ConfigParser.y"
    {
	    (yyval.integer) = atoi( flexer->YYText() );
	;}
    break;

  case 135:
#line 613 ".././/ConfigParser.y"
    {
	    (yyval.string) = strdup( flexer->YYText() );
	;}
    break;

  case 136:
#line 619 ".././/ConfigParser.y"
    {
	    (yyval.string) = strdup( flexer->YYText() );
	;}
    break;

  case 137:
#line 626 ".././/ConfigParser.y"
    {
	    int n;
	    sscanf( flexer->YYText(), "0x%x", &n );
	    (yyval.integer) = n;
	;}
    break;

  case 138:
#line 633 ".././/ConfigParser.y"
    { (yyval.boolean) = true;;}
    break;

  case 139:
#line 633 ".././/ConfigParser.y"
    { (yyval.boolean) = false; ;}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2250 "ConfigParser.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 636 ".././/ConfigParser.y"


static void yyerror( const char *errmsg )
{
    fprintf( stderr, 
    	"CameraConfig::parseFile(\"%s\") : %s - Line %d at or before \"%s\"\n",
		fileName.c_str(),
		errmsg, 
        flexer->lineno(),
        flexer->YYText() );
}

bool CameraConfig::parseFile( const std::string &file )
{
    fileName.clear();

    fileName = findFile(file);

    if( fileName.empty() )
    {
        fprintf( stderr, "CameraConfig::parseFile() - Can't find file \"%s\".\n", file.c_str() );
        return false;
    }

    bool retval = true;

#if defined (SUPPORT_CPP)

    char *cpp_path =
  #if defined(__APPLE__)
                "/usr/bin/cpp";
  #else
                "/lib/cpp";
  #endif

    if( access( cpp_path, X_OK ) == 0 )
    {

        int pd[2];
        pipe( pd );

        flexer = new yyFlexLexer;
        if( fork() == 0 )
        {
            // we don't want to read from the pipe in the child, so close it.
            close( pd[0] );
            close( 1 );
            dup( pd[1] );


            /* This was here to allow reading a config file from stdin.
             * This has never been directly supported, so commenting out.
            if( fileName.empty() )
                execlp( cpp_path, "cpp",  "-P", 0L );
            else
            */
            execlp( cpp_path, "cpp",  "-P", fileName.c_str(), 0L );

            // This should not execute unless an error happens
            perror( "execlp" );
        }
        else
        {
            close( pd[1]);
            close( 0 );
            dup( pd[0] );

            cfg = this;

            retval = ConfigParser_parse() == 0 ? true : false;

            // Wait on child process to finish
            int stat;
            wait( &stat );
        }
    }
    else
#endif
    {
        std::ifstream ifs(fileName.c_str());
        flexer = new yyFlexLexer(&ifs);
        cfg = this;
        retval = ConfigParser_parse() == 0 ? true : false;
        ifs.close();
        delete flexer;
    }
    return retval;
}


